/* Ejercicio punteros y vectores 6/6/15
 * Curso R1021
 *
 * Consigna: Desarrolle un programa que pida 100 numeros enteros al usuario,
 *           filtre aquellos que son pares y los que son positivos, y los
 *           imprima por pantalla. Utilice vectores para su resolución.
 *
 * main.c - Función main();
 * Autor: Leandro Kollenberger
 * Observaciones: en lugar de pedir 100 numeros como dice la consigna,
 *                se ha agregado un #define con una constante para que sea
 *                más fácil la prueba del ejercicio.
 *
 * Linea de compilacion: gcc main.c funciones.c -o ejercicio -Wall
 *
 */

#include <stdio.h>
#include "header.h"

int main(void) {

    int i;                   // Contador de ciclo.

    int entrada[MAX];        // Vector de enteros ingresados por el usuario.

    int positivos[MAX];      // Vector de enteros positivos filtrados.
    int positivos_filtrados; // Cantidad de números positivos filtrados.

    int pares[MAX];          // Vector de enteros pares filtrados.
    int pares_filtrados;     // Cantidad de números pares filtrados.

    // Ingreso los "MAX" números por teclado...

    for(i = 0; i < MAX; i++) {
        printf("Ingrese numero %d: ", (i+1) );
        scanf ("%d", &entrada[i] );
    }

    /* Los filtro... Estas funciones me devolverán la cantidad de números
     * procesados, de esa forma los puedo imprimir sin pasar por regiones de
     * memoria que nunca toqué, y que pueden tener basura.
     * Por ejemplo: suponer que el vector es de 10 números, pero sólo procesé 3.
     * En caso de que quiera imprimir todo el vector por pantalla, los otros
     * 7 datos tienen basura de la memoria, ya que nunca los escribí.
     */
    positivos_filtrados = filtrar_positivos(entrada, positivos, MAX);
    pares_filtrados = filtrar_pares(entrada, pares, MAX);

    printf("\nSe han filtrado los siguientes %d numeros positivos: ",
        positivos_filtrados);

    // Como fue dicho anteriormente, imprimo únicamente los filtrados.
    for(i = 0; i < positivos_filtrados; i++) {
        printf("%d ", positivos[i]);
    }

    printf("\nSe han filtrado los siguientes %d numeros pares: ",
        pares_filtrados);

    // Ídem.
    for(i = 0; i < pares_filtrados; i++) {
        printf("%d ", pares[i]);
    }

    printf("\n");

    return 0;
}
